diff --git a/core/unix/loader.c b/core/unix/loader.c
index e2f65df295b..77ba1bcc432 100644
--- a/core/unix/loader.c
+++ b/core/unix/loader.c
@@ -1441,6 +1441,11 @@ static const redirect_import_t redirect_imports[] = {
     {"memcmp", (app_pc)memcmp},
     {"strstr", (app_pc)strstr},
     {"strcasecmp", (app_pc)strcasecmp},
+    /* Also redirect the _chk versions (i#1747, i#46) */
+    {"memcpy_chk", (app_pc)memcpy},
+    {"memset_chk", (app_pc)memset},
+    {"memmove_chk", (app_pc)memmove},
+    {"strncpy_chk", (app_pc)strncpy},
 };
 #define REDIRECT_IMPORTS_NUM (sizeof(redirect_imports)/sizeof(redirect_imports[0]))
 
diff --git a/make/DynamoRIOConfig.cmake.in b/make/DynamoRIOConfig.cmake.in
index 455bb796bc7..fa412f331d5 100755
--- a/make/DynamoRIOConfig.cmake.in
+++ b/make/DynamoRIOConfig.cmake.in
@@ -678,6 +678,10 @@ function (configure_DynamoRIO_common target is_client x64_var defs_var)
 
     if (NOT DynamoRIO_USE_LIBC AND NOT tgt_cxx AND is_client)
       set(tgt_cflags "${tgt_cflags} -nostdlib")
+      if (APPLE)
+        # Avoid errors about missing the _chk versions of memcpy, etc.
+        set(tgt_link_flags "${tgt_link_flags} -undefined dynamic_lookup")
+      endif (APPLE)
     endif ()
 
     # gcc is invoked for the link step so we have to repeat cflags as well
